<template>
  <v-menu open-on-hover offset-y>
    <template #activator="{ on: menu, attrs }">
      <v-btn
        v-if="icon"
        depressed
        icon
        :aria-label="ariaLabel"
        :disabled="disableMenu"
        :class="btnClass"
        small
        class="mx-1"
        v-bind="{ ...attrs, ...$attrs }"
        v-on="{ ...menu }"
      >
        <v-icon :color="color">{{ icon }}</v-icon>
      </v-btn>
      <v-btn
        v-else
        block
        :aria-label="ariaLabel"
        :disabled="availableElements.length === 0"
        :class="btnClass"
        small
        v-bind="{ ...attrs, ...$attrs }"
        v-on="{ ...menu }"
        ><v-icon>mdi-plus</v-icon>{{ text }}
      </v-btn>
    </template>

    <v-list v-if="availableElementsNested">
      <div v-for="item in availableElements" :key="item.title">
        <v-list-group v-if="item.elements.length > 0" no-action @click.stop>
          <template #activator>
            <v-list-item-title>{{ item.title }}</v-list-item-title>
          </template>

          <v-list-item
            v-for="(element, index) in item.elements"
            :key="index"
            @click="element.addElement"
          >
            <v-list-item-title>{{ element.text }}</v-list-item-title>
          </v-list-item>
        </v-list-group>
      </div>
    </v-list>

    <v-list v-else>
      <v-list-item
        v-for="(item, index) in availableElements"
        :key="index"
        @click="item.addElement"
      >
        <v-list-item-title>{{ item.text }}</v-list-item-title>
      </v-list-item>
    </v-list>
  </v-menu>
</template>

<script>
export default {
  name: "GDropDownMenu",
  props: {
    i18n: String,
    label: String,
    btnClass: String,
    availableElements: Array,
    color: {
      type: String,
      default: "",
    },
    icon: {
      type: String,
    },
  },
  computed: {
    text() {
      return this.i18n ? this.$t(this.i18n) : this.label;
    },
    ariaLabel() {
      return this.subheader ? this.$t(this.subheader) : this.text;
    },
    availableElementsNested() {
      return (
        this.availableElements.length > 0 &&
        this.availableElements.every((x) => x.elements)
      );
    },
    disableMenu() {
      if (this.availableElementsNested)
        return this.availableElements.reduce((result, item) => {
          return result && item.elements.length < 1;
        });
      else return this.availableElements.length === 0;
    },
  },
};
</script>
